#include <stdio.h>
#include <unistd.h>
#include <pthread.h>

#define NUM_THREADS 10
#define COUNT_MAX 1000000

int count = 0;
static int my_count[NUM_THREADS];

pthread_mutex_t mx = PTHREAD_MUTEX_INITIALIZER;


void
show_count()
{
	int i;

	for (i = 1; i < NUM_THREADS; i++)
		printf(" %7d", my_count[i]);
	printf("\r");
	fflush(stdout);
}

void
thread_count(void *arg)
{
	int *my_id=(int *)arg;

	for ( ; ; ) {
		pthread_mutex_lock(&mx);
		if (count == COUNT_MAX) {
			pthread_mutex_unlock(&mx);
			return;
		}
		count++;
		pthread_mutex_unlock(&mx);
		my_count[*my_id]++;
	}
}

void
thread_observer(void *arg)
{
	int i;

	while (count != COUNT_MAX) {
		printf("%7d:", count);
		show_count();
		sleep(1);
	}
	printf("%7d:", count);
	show_count();
	printf("\n");
}

int
main()
{
	int i;
	pthread_t threads[NUM_THREADS];
	int id_arg[NUM_THREADS];

	pthread_create(&(threads[0]),
			NULL,
			thread_observer,
			(void *) &(id_arg[0]));

	for (i = 1; i < NUM_THREADS; i++) {

		id_arg[i] = i;

		pthread_create(&(threads[i]),
				NULL,
				thread_count,
				(void *) &(id_arg[i]));
	}

	for (i = 0; i < NUM_THREADS; i++)
		pthread_join(threads[i], NULL);

}
